#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "math.h"
#include <QString>
#include <stdlib.h>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    ui->tableWidget->setColumnCount(2);
    ui->tableWidget->setRowCount(7);
    ui->tableWidget->setColumnWidth(0,65);
    ui->tableWidget->setColumnWidth(1,65);
    for(int i=0; i<7; ++i){
        ui->tableWidget->setRowHeight(i,25);
    }
    x = new double[7];
    y = new double[7];
    d = new double *[7];
    buf = new QTableWidgetItem *[7];
    for (int i=0; i<7; ++i){
        *(buf+i) = new QTableWidgetItem[2];
        *(d+i) = new double[7];
    }
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::sozdxy(){
    for(int i =0; i <7; i++) {
                x[i] = i+1;
                y[i] = f(x[i]);
    }
}

double MainWindow::f(double x){
    return 2.3*log(x/2)+sin(x)*sin(x);
}

QString ds(double p){
    QString s="";
    s.setNum(p);
    return s;
}

void MainWindow::on_pushButton_clicked()
{
    *(x+6) = 8.7;
    *(y+6) = f(x[6]);
    buf[6]->setText(ds(*(x+6)));
    ui->tableWidget->setItem(6,0,buf[6]);

    (buf[6]+1)->setText(ds(*(y+6)));
    ui->tableWidget->setItem(6,1,(buf[6]+1));

    *(x) = 1;
    *(y) = f(x[0]);
    buf[0]->setText(ds(*(x)));
    ui->tableWidget->setItem(0,0,buf[0]);

    (buf[0]+1)->setText(ds(*(y)));
    ui->tableWidget->setItem(0,1,(buf[0]+1));

    for (int i = 1; i<6; i++) {
        x[i] = random();
        while (x[i]>99){
            x[i]=x[i] / 2;
        }
        x[i] = x[i]/100+i+1*i/2;
        y[i] = f(x[i]);

        buf[i]->setText(ds(*(x+i)));
        ui->tableWidget->setItem(i,0,buf[i]);

        (buf[i]+1)->setText(ds(*(y+i)));
        ui->tableWidget->setItem(i,1,(buf[i]+1));
    }
}

void MainWindow::on_textEdit_textChanged()
{
    ui->textEdit_2->setText(ds(f(ui->textEdit->toPlainText().toDouble())));
}

void MainWindow::on_pushButton_2_clicked()
{
        double nx = ui->textEdit_3->toPlainText().toDouble();
        double d, ml=0;
        for (int i=0; i<7; ++i)
        {
                d=1;
                for (int j=0; j<7; ++j){
                    if (i!=j){
                        d *= (nx-x[j]) / (x[i]-x[j]);
                    }
                }
                ml+=d*y[i];
        }
        ui->textEdit_4->setText(ds(ml));
}

void MainWindow::on_pushButton_3_clicked()
{
sozdxy();
for(int i = 0; i<7; i++) {
    buf[i]->setText(ds(x[i]));
    ui->tableWidget->setItem(i,0,buf[i]);
    (buf[i]+1)->setText(ds(y[i]));
    ui->tableWidget->setItem(i,1,(buf[i]+1));
}

for (int i = 0; i<=6; i++) {
     d[0][i] = y[i+1] - y[i];
}

for (int i = 1; i<7; i++){
    for(int j = 0; j< 7-i; j++) {
        d[i][j] = d[i-1][j+1] - d[i-1][j];
    }
}
double nx = ui->textEdit_3->toPlainText().toDouble();
double mn1 = y[0];
double t = nx - x[0];
double el;
for(int i = 1; i<=6; i++) {
        el = 1;
        for(int j = 1; j<=i; j++) {
                el *= (t - j + 1)/j;
        }

        mn1+=el* d[i-1][0];
}
ui->textEdit_4->setText(ds(mn1));

}

void MainWindow::on_pushButton_4_clicked()
{
sozdxy();
for(int i = 0; i<7; i++) {
    buf[i]->setText(ds(x[i]));
    ui->tableWidget->setItem(i,0,buf[i]);
    (buf[i]+1)->setText(ds(y[i]));
    ui->tableWidget->setItem(i,1,(buf[i]+1));
}

for (int i = 0; i<6; i++) {
     d[0][i] = y[i+1] - y[i];
}

for (int i = 1; i<7; i++){
    for(int j = 0; j< 7-i; j++) {
        d[i][j] = d[i-1][j+1] - d[i-1][j];
    }
}
double nx = ui->textEdit_3->toPlainText().toDouble();
double mn2 = y[6];
double t = nx - x[6];
double el;
for(int i = 1; i<=6; i++) {
        el = 1;
        for(int j = 1; j<=i; j++) {
                el *= (t + j - 1)/j;
        }

        mn2+=el* d[i-1][6-i];
}
ui->textEdit_4->setText(ds(mn2));



}
